#!/usr/bin/python
#
# Copyright 2009 Marcelo Boveto Shima.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA    02110-1301, USA.
#
# Author: marceloshima@gmail.com (Marcelo Boveto Shima)

#import gconf
import os
import shutil

#client = gconf.client_get_default ()

class keyboard:
    def __init__( self, session ):
        self.model = None
        self.rules = None
        self.keyboard_file_path = session.get_keyboard_file_path( )
    
    def set_kbd( self ):
        if self.rules is not None and self.rules is not "":
            ret = os.spawnlp( os.P_WAIT, "setxkbmap", "setxkbmap", "-rules", self.rules )
            if ret is not 0 and self.rules is "evdev":
                self.model = "evdev"
        
        if self.model is not None and self.model is not "":
            ret = os.spawnlp( os.P_WAIT, "setxkbmap", "setxkbmap", "-model", self.model )
        #client.set_string ( "/desktop/gnome/peripherals/keyboard/kbd/model", model )
        #ret = os.spawnlp( os.P_WAIT, "killall", "killall", "gnome-settings-daemon" )
        #ret = os.spawnlp( os.P_WAIT, "killall", "killall", "metacity" )

    def get_configs( self, keyboard_file_path ):
        rules = None
        model = None
        if keyboard_file_path is not None:
            keyboard_file = open( keyboard_file_path ,'r' )
            
            for line in keyboard_file.readlines():
                split = str.split( line, "=" )
                if split[0] is "rules":
                    rules = split[1]
                elif split[0] is "model":
                    model = split[1]
        return (rules, model)

    def update_kbd( self ):
        configs1 = self.get_configs( self.keyboard_file_path )
        configs2 = self.get_configs( self.keyboard_file_path + ".last" )
        
        rules = None
        model = None
        if configs1[0] is not configs1[0]:
            rules = configs1[0]
        if configs1[1] is not configs1[1]:
            model = configs1[1]

        if rules is not None and rules is not "":
            self.rules = rules
        if model is not None and model is not "":
            self.model = model

        self.set_kbd( )
        
        shutil.copyfile( keyboard_file_path, keyboard_file_path + ".last" )
