#!/usr/bin/env python
#
# Copyright 2009 Marcelo Boveto Shima.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA    02110-1301, USA.
#
# Author: marceloshima@gmail.com (Marcelo Boveto Shima)

import sys
from tacix.freenx.FreeNXProtocol import FreeNXProtocol

class FreeNXServerProtocol(FreeNXProtocol):
    def exit(self):
        self.say_bye()

    # Output functions
    def send_client(self, line):
        sys.stdout.write(line)
        sys.stdout.flush()

    def say_server_prompt(self):
        self.send_client('NX> 105 ')

    def say_server_hello(self):
        self.send_client('HELLO NXSERVER - Version 3.3.0-1 OS (TX)\n')
        self.send_client('NX> 105 ')

    def say_server_bye(self, line):
        self.send_client(line + '\n')
        self.send_client( "Bye\n" )
        self.send_client( "NX> 999 Bye.\n" )

    def say_server_welcome(self, hostname, user):
        self.send_client('\nNX> 103 Welcome to: %s user: %s\n' % (hostname, user))
        self.send_client('NX> 105 ')

    def say_server_login_failed(self):
        self.send_client('NX> 404 ERROR: wrong password or login')

    def say_server_password(self, line):
        self.send_client(line + '\n')
        self.send_client('\nNX> 102 Password: ')

    def say_server_user(self, line):
        self.send_client(line + '\n')
        self.send_client('NX> 101 User: ')

    def say_server_accepted(self, line):
        self.send_client(line + '\n')
        self.send_client('NX> 134 Accepted protocol: 3.3.0\n')
        self.send_client('NX> 105 ')

